#pragma once
#include "abstractrangerule.hpp"
#include "../clonablemacros.hpp"
#include "../classnamemacros.hpp"

/// @brief Represents an update rule specifying that a numerical variable changes within
/// a certain interval
class ChangeRangeRule : public AbstractRangeRule
{
    public:
    ChangeRangeRule(const std::shared_ptr<NumericalVariable>& variable, double_t min, double_t max);
    NAME_DERIVED_CLASS
    CLONABLE_CHILD(ChangeRangeRule)
    virtual std::string toString() const;
};
