#include <capnp/ez-rpc.h>
#include "capnproto/serverimplementation.hpp"
#include <iostream>
#include <unistd.h>
#include <limits.h>

int main(int argc, const char* argv[])
{
    const int port = 21654;
    // Set up the EzRpcServer, binding to port 21654 unless a
    // different port was specified by the user.  Note that the
    // first parameter here can be any "Client" object or anything
    // that can implicitly cast to a "Client" object.  You can even
    // re-export a capability imported from another server.
    capnp::EzRpcServer server(kj::heap<ServerImplementation>(), "0.0.0.0", port);
    auto& waitScope = server.getWaitScope();

    // get current host name
    char hostname[HOST_NAME_MAX];
    gethostname(hostname, HOST_NAME_MAX);
    
    std::cout << "Server listening on " << hostname << ":" << port << std::endl;

    // Run forever, accepting connections and handling requests.
    kj::NEVER_DONE.wait(waitScope);
}
