#include <gtest/gtest.h>
#include <stdexcept>
#include "../classes/scoring/mdlcalculator.hpp"

TEST(MdlCalculatorIntegerTest, MinTest)
{
    MdlCalculator calc;
    EXPECT_THROW(calc.codePositiveInteger(INT64_MIN + 1), std::domain_error);
}

TEST(MdlCalculatorIntegerTest, ValidMinTest)
{
    MdlCalculator calc;
    EXPECT_DOUBLE_EQ(75.893525072731292, calc.codeInteger(INT64_MIN + 2));
}

TEST(MdlCalculatorIntegerTest, NegativeMidTest)
{
    MdlCalculator calc;
    EXPECT_DOUBLE_EQ(21.172996488671597, calc.codeInteger(-4999));
}

TEST(MdlCalculatorIntegerTest, ZeroTest)
{
    MdlCalculator calc;
    EXPECT_DOUBLE_EQ(2.518567366364848, calc.codeInteger(0));
}

TEST(MdlCalculatorIntegerTest, PositiveMidTest)
{
    MdlCalculator calc;
    EXPECT_DOUBLE_EQ(21.172996488671597, calc.codeInteger(4999));
}

TEST(MdlCalculatorIntegerTest, ValidMaxTest)
{
    MdlCalculator calc;
    EXPECT_DOUBLE_EQ(75.893525072731292, calc.codeInteger(INT64_MAX - 1));
}

TEST(MdlCalculatorIntegerTest, MaxTest)
{
    MdlCalculator calc;
    EXPECT_THROW(calc.codeInteger(INT64_MAX), std::domain_error);
}
