#include <gtest/gtest.h>
#include <stdexcept>
#include "../classes/scoring/mdlcalculator.hpp"

TEST(MdlCalculatorPositiveIntegerTest, MinTest)
{
    MdlCalculator calc;
    EXPECT_THROW(calc.codePositiveInteger(INT64_MIN), std::domain_error);
}

TEST(MdlCalculatorPositiveIntegerTest, NegativeTest)
{
    MdlCalculator calc;
    EXPECT_THROW(calc.codePositiveInteger(-1), std::domain_error);
}

TEST(MdlCalculatorPositiveIntegerTest, ZeroTest)
{
    MdlCalculator calc;
    EXPECT_THROW(calc.codePositiveInteger(0), std::domain_error);
}

TEST(MdlCalculatorPositiveIntegerTest, OneTest)
{
    MdlCalculator calc;
    EXPECT_DOUBLE_EQ(1.518567366364848, calc.codePositiveInteger(1));
}

TEST(MdlCalculatorPositiveIntegerTest, MidTest)
{
    MdlCalculator calc;
    EXPECT_DOUBLE_EQ(20.172996488671597, calc.codePositiveInteger(5000));
}

TEST(MdlCalculatorPositiveIntegerTest, MaxTest)
{
    MdlCalculator calc;
    EXPECT_DOUBLE_EQ(74.893525072731292, calc.codePositiveInteger(INT64_MAX));
}
