#pragma once
#include "gmock/gmock.h"
#include "../classes/preprocessing/distributionestimator.hpp"

class MockDistributionEstimator : public DistributionEstimator
{
    public:
    MOCK_METHOD(void, calculateGlobalDistributions, (const EventLog* const log), (override));
    MOCK_METHOD(double_t, getGlobalProbability,
        (const std::shared_ptr<CategoricalVariable>& variable, const std::string& value),
        (override));
    MOCK_METHOD(double_t, getGlobalProbability,
        (const std::shared_ptr<NumericalVariable>& variable, const double_t value),
        (override));
    MOCK_METHOD(double_t, getRuleProbability,
        (const ValueSetRule* const rule, const std::string& value), (override));
    MOCK_METHOD(double_t, getRuleProbability,
        (const UpdateRule* const rule), (override));
    MOCK_METHOD(double_t, getAccuracy, (const std::shared_ptr<NumericalVariable> variable),
        (const override));
    MOCK_METHOD(const CatDistributionType&, getCategoricalDistribution,
        (const std::shared_ptr<CategoricalVariable>& variable), (const override));
    MOCK_METHOD(const Histogram&, getNumericalDistribution,
        (const std::shared_ptr<NumericalVariable>& variable), (const override));
};
