#pragma once
#include "gmock/gmock.h"
#include "../classes/scoring/modelencoder.hpp"

class MockModelEncoder : public ModelEncoder {
    public:
    MockModelEncoder(const std::shared_ptr<MdlCalculator> calc, const int64_t numberOfVariables, const int64_t precision)
        : ModelEncoder(calc, numberOfVariables, precision)
    {}

    MOCK_METHOD(double_t, encodeUpdateRule, (const UpdateRule* const updateRule), (override));
    MOCK_METHOD(double_t, encodeCondition, (const Condition* const condition), (override));
};
