FROM maven:3.9

# Add additional root CA if available
RUN apt-get update \
    && apt-get -y install ca-certificates \
    && mkdir -p /tmp/certificate-setup
# optionally copy the additional root CA
COPY dummycopy.txt root-ca.cr[t] /tmp/certificate-setup/
# setup the new root CA if available and cleanup
RUN cp /tmp/certificate-setup/*.crt /usr/local/share/ca-certificates/ 2>/dev/null || : \
    && update-ca-certificates \
    && openssl x509 -in /tmp/certificate-setup/*.crt -inform pem \
        -out /tmp/certificate-setup/ca.der -outform der \
    && keytool -importcert -alias customrootca -keystore $JAVA_HOME/lib/security/cacerts \
        -storepass changeit -file /tmp/certificate-setup/ca.der -noprompt \
    && rm -rf /tmp/certificate-setup
ENV NODE_EXTRA_CA_CERTS=/etc/ssl/certs/ca-certificates.crt

# download and install MINT tool
RUN cd /root \
    && curl -L -o mintframework.tar.gz https://github.com/neilwalkinshaw/mintframework/tarball/master \
    && tar zxf mintframework.tar.gz \
    && rm -rf mintframework.tar.gz \
    && mv neilwalkinshaw-mintframework-* mintframework \
    && cd mintframework \
    && mvn install -DskipTests
