from .dataframetocapnp import *
import numpy as np

def addSwapNoiseToMessage(eventLogMessage, proportion=0.1, disableProgressBar=False):
    dataframe = dataframeFromMessage(eventLogMessage, disableProgressBar=disableProgressBar)
    addSwapNoise(dataframe, proportion)
    return dataframeToMessage(dataframe, variables=list(eventLogMessage.as_builder().variables),
                              disableProgressBar=disableProgressBar)

def addSwapNoise(dataframe, proportion=0.1, caseIdColumn="case:concept:name"):
    numberOfValuesToShuffle = int(len(dataframe) * proportion)

    columnsToShuffle = list(dataframe.columns)
    columnsToShuffle.remove(caseIdColumn)

    for column in columnsToShuffle:
        indicesToShuffle = np.random.choice(dataframe.index, numberOfValuesToShuffle, replace=False)
        valuesToShuffle = list(dataframe[column][indicesToShuffle])
        shuffledIndices = np.copy(indicesToShuffle)
        np.random.shuffle(shuffledIndices)
        for newIndex, value in zip(shuffledIndices, valuesToShuffle):
            dataframe.loc[newIndex, column] = value
