import os
import shutil

# fix working directory
import os
abspath = os.path.abspath(__file__)
dname = os.path.dirname(abspath)
os.chdir(dname)

import capnp
capnp.remove_import_hook()
interface_capnp = capnp.load("../../cpp-tool/capnproto/interface.capnp", imports=["/usr/local/include"])

import sys
sys.path.append("../..")
from experiments.modelgeneration import ModelGenerator

# connect to my server
client = capnp.TwoPartyClient("cpp-tool:21654")
processDataUpdatesCpp = client.bootstrap().cast_as(interface_capnp.ProcessDataUpdates)

modelGen = ModelGenerator(interface_capnp, processDataUpdatesCpp, {"tree": None})

# ==================== CATEGORICAL TARGETS ====================
# clean start for the experiment
experimentName = "decisionTreeNoiseCat"
shutil.rmtree(experimentName, ignore_errors=True)
os.mkdir(experimentName)

# copy models from categorical SSD++ experiment
sourceFolder = "ssdppNoiseVariationCategorical"
for fileName in os.listdir(sourceFolder):
    if fileName[:2] == "--": # true or empty model
        shutil.copy(sourceFolder + "/" + fileName, experimentName + "/" + fileName)
# load true models
trueModels = []
for fileName in sorted(os.listdir(experimentName)):
    if "true-model" in fileName:
        with open(experimentName + "/" + fileName, "rb") as file:
            trueModels.append(interface_capnp.RuleModel.read(file))

# estimate models with varying noise
modelGen.generateModelEstimates(experimentName, trueModels, [0.0, 0.1, 0.2, 0.3], [2000], 10)
